# Allow target distro to be overridden using: rpmbuild --define "distro fc3"
# Valid values for distro are: fc3 fc4 fc5 fc6 fc7 fc8 fc9 fc10 fc11 fc12 fc13 fc14 fc15 fc16 fc17 fc18 fc19 fc20 fc21 fc22 fc23 fc24 devel rhel3 rhel4 rhel5 rhel6 rhel7

# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# For the special case of Rawhide, use "devel" as the distro
%if "%{__distname}" == "Rawhide"
%global __distvers %{nil}
%global __distinit devel
%endif
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Set distribution booleans
%{!?distro: %global distro %{__distinit}%{__distvers}}
%global rhel6	%(if [ "%{distro}" == "rhel6"	]; then echo 1; else echo 0; fi)
%global rhel7	%(if [ "%{distro}" == "rhel7"	]; then echo 1; else echo 0; fi)
%global rhel8	%(if [ "%{distro}" == "rhel8"	]; then echo 1; else echo 0; fi)
%global fc13	%(if [ "%{distro}" == "fc13"	]; then echo 1; else echo 0; fi)
%global fc14	%(if [ "%{distro}" == "fc14"	]; then echo 1; else echo 0; fi)
%global fc15	%(if [ "%{distro}" == "fc15"	]; then echo 1; else echo 0; fi)
%global fc16	%(if [ "%{distro}" == "fc16"	]; then echo 1; else echo 0; fi)
%global fc17	%(if [ "%{distro}" == "fc17"	]; then echo 1; else echo 0; fi)
%global fc18	%(if [ "%{distro}" == "fc18"	]; then echo 1; else echo 0; fi)
%global fc19	%(if [ "%{distro}" == "fc19"	]; then echo 1; else echo 0; fi)
%global fc20	%(if [ "%{distro}" == "fc20"	]; then echo 1; else echo 0; fi)
%global fc21	%(if [ "%{distro}" == "fc21"	]; then echo 1; else echo 0; fi)
%global fc22	%(if [ "%{distro}" == "fc22"	]; then echo 1; else echo 0; fi)
%global fc23	%(if [ "%{distro}" == "fc23"	]; then echo 1; else echo 0; fi)
%global fc24	%(if [ "%{distro}" == "fc24"	]; then echo 1; else echo 0; fi)
%global fc25	%(if [ "%{distro}" == "fc25"	]; then echo 1; else echo 0; fi)
%global fc26	%(if [ "%{distro}" == "fc26"	]; then echo 1; else echo 0; fi)
%global fc27	%(if [ "%{distro}" == "fc27"	]; then echo 1; else echo 0; fi)
%global fc28	%(if [ "%{distro}" == "fc28"	]; then echo 1; else echo 0; fi)
%global fc29	%(if [ "%{distro}" == "fc29"	]; then echo 1; else echo 0; fi)
%global fc30	%(if [ "%{distro}" == "fc30"	]; then echo 1; else echo 0; fi)
%global fc31	%(if [ "%{distro}" == "fc31"	]; then echo 1; else echo 0; fi)
%global fc32	%(if [ "%{distro}" == "fc32"	]; then echo 1; else echo 0; fi)
%global fc33	%(if [ "%{distro}" == "fc33"	]; then echo 1; else echo 0; fi)
%global fc34	%(if [ "%{distro}" == "fc34"	]; then echo 1; else echo 0; fi)
%global fc35	%(if [ "%{distro}" == "fc35"	]; then echo 1; else echo 0; fi)
%global fc36	%(if [ "%{distro}" == "fc36"	]; then echo 1; else echo 0; fi)
%global devel	%(if [ "%{distro}" == "devel"	]; then echo 1; else echo 0; fi)

# Require dnf rather than yum from Fedora 22 onwards
%global prefer_dnf %([ "(" "%{__distinit}" == "fc" -a %{__distvers} -gt 21 ")" -o "(" "%{__distinit}" == "rhel" -a %{__distvers} -gt 7 ")" ] && echo 1 || echo 0)

Summary:	Release file and package configuration for city-fan.org repository
Name:		city-fan.org-release
Version:	2
Release:	1.%{distro}
License:	GPLv2+
URL:		http://www.city-fan.org/ftp/contrib/yum-repo/
Source0:	GPL
Source1:	RPM-GPG-KEY-city-fan.org
Source2:	city-fan.org.repo
Source3:	city-fan.org-development.repo
%if %{prefer_dnf}
Requires:	dnf
%else
Requires:	yum >= 2.2.1
%endif
BuildArch:	noarch

%description
city-fan.org release file. This package also contains yum configuration to
use the city-fan.org provided rpm packages, as well as the public gpg key
used to sign them.

You will still need to manually enable the city-fan.org repository in your
package manager after installing this package.

%prep
%setup -c -T
cp -a %{SOURCE0} %{SOURCE1} .
%if %{devel}
cp -a %{SOURCE3} city-fan.org.repo
%else
cp -a %{SOURCE2} city-fan.org.repo
%endif
%if %{rhel6} || %{rhel7} || %{rhel8}
sed -i -e 's@\([-/]\)fc\$@\1rhel$@' city-fan.org.repo
sed -i -e 's@Fedora@Red Hat Enterprise Linux (and clones)@' city-fan.org.repo
%endif

%build

%install
# Install gpg key
install -m 0755 -d %{buildroot}%{_sysconfdir}/pki/rpm-gpg
install -m 0644 RPM-GPG-KEY-city-fan.org %{buildroot}%{_sysconfdir}/pki/rpm-gpg/

# Install repo files
install -D -m 0644 city-fan.org.repo \
	%{buildroot}%{_sysconfdir}/yum.repos.d/city-fan.org.repo

%files
%doc GPL
%config(noreplace) %{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org
%pubkey RPM-GPG-KEY-city-fan.org
%config(noreplace) %{_sysconfdir}/yum.repos.d/city-fan.org.repo

%changelog
* Thu Feb  1 2018 Paul Howarth <paul@city-fan.org> - 2-1
- Don't enable the repository by default
- Drop support for EOL distributions prior to Fedora 13
- Support Fedora releases up to 36

* Fri Jul  3 2015 Paul Howarth <paul@city-fan.org> - 1-13
- Require dnf rather than yum from Fedora 22 onwards
- Support Fedora releases up to 28

* Fri Sep 21 2012 Paul Howarth <paul@city-fan.org> - 1-12
- Add debuginfo and source repositories
- Support Fedora releases up to 24
- Merge the regular and development repo configurations and ship only the
  former, even on Rawhide

* Fri Jul 29 2011 Paul Howarth <paul@city-fan.org> - 1-10
- Update GPLv2 text for FSF address change
- Fix dist tag for CentOS 6 and Scientific Linux
- Nobody else likes macros for commands

* Fri Feb 11 2011 Paul Howarth <paul@city-fan.org> - 1-9
- Support Fedora releases up to 20

* Mon Jun  8 2009 Paul Howarth <paul@city-fan.org> - 1-8
- Use setup macro in %%prep to run in a subdir

* Tue May 19 2009 Paul Howarth <paul@city-fan.org> - 1-7
- Define macros in global context
- Only refer to "Fedora Core" for releases prior to Fedora 7

* Fri Mar 23 2007 Paul Howarth <paul@city-fan.org> - 1-6
- Add CentOS 5 support and look forward to future releases
- Add empty %%build section

* Mon Jan  8 2007 Paul Howarth <paul@city-fan.org> - 1-5
- Add CentOS 4 support (same as FC3)

* Tue Oct 31 2006 Paul Howarth <paul@city-fan.org> - 1-4
- Add Fedora Core 6 and Rawhide support
- Include architecture in baseurls

* Tue Mar 21 2006 Paul Howarth <paul@city-fan.org> - 1-3
- Add Fedora Core 5 support
- Update distribution-detection code
- Remove buildroot unconditionally in %%clean and %%install

* Thu Jul 14 2005 Paul Howarth <paul@city-fan.org> - 1-2
- Use gpgkey= in city-fan.org.repo and require yum ≥ 2.2.1
- Don't auto-import GPG key in %%post
- Make fc3 and fc4 specific versions of package (different gpg key locations)

* Mon Nov 15 2004 Paul Howarth <paul@city-fan.org> - 1-1
- Initial RPM release, inspired by fedora-release
